<template>
  <section id="iniciativas" class="container search">     
    <h3 class="subtitle has-text-centered">Soluções do 1º Desafio: <span>Tecnologias Sociais</span></h3>
     <div class="columns">
      <div class="column is-6 has-text-centered">
        <div class="field">         
          <p class="control">
            <input class="input" type="text" placeholder="Busca" v-model="filter.q">
          </p>        
        </div>        
      </div>

      <div class="column is-5 mobile has-text-centered">
        <multiselect
          v-model="filter.ods"
          placeholder="ODS"
          :options="options"
          label="title"
          selectLabel="Pressione Enter para selecionar"
          selectedLabel="Selecionado"
          deselectLabel="Pressione Enter para remover"
        >
        </multiselect>        
      </div>
      <div class="column mobile">
        <button
          class="button is-filter is-info"
          @click="sendEvent()"
          v-if="!showClearFilterBtn"
          :disabled="filter.q == '' && filter.ods.length === 0"
        >
          <i class="fa fa-search"></i>
        </button>
        <button
          class="button is-clear is-danger"
          @click="clearFilter()"
          v-else
        >
          <i class="fa fa-times"></i>
        </button>
      </div>
    </div>

    <div class="tags has-text-centered">
      <button class="button" :class="{ ' active': filterButtons.actionComment }" @click="getInitiativesByAction('actionComment')"><span class="fa fa-plus"></span>&nbsp;Comentadas</button>
      <button class="button" :class="{ ' active': filterButtons.actionShare }" @click="getInitiativesByAction('actionShare')"><span class="fa fa-plus"></span>&nbsp;Compartilhadas</button>
      <button class="button" :class="{ ' active': filterButtons.actionView }" @click="getInitiativesByAction('actionView')"><span class="fa fa-plus"></span>&nbsp;Visualizadas</button>
      <button class="button" :class="{ ' active': filterButtons.actionLike }" @click="getInitiativesByAction('actionLike')"><span class="fa fa-plus"></span>&nbsp;Avaliadas</button>
      <button class="button" :class="{ ' active': filterButtons.actionDonate }" @click="getInitiativesByAction('actionDonate')"><span class="fa fa-plus"></span>&nbsp;Apoiadas</button>
      <button class="button" :class="{ ' active': filterButtons.actionFavorite }" @click="getInitiativesByAction('actionFavorite')"><span class="fa fa-plus"></span>&nbsp;Favoritadas</button>
    </div>

  </section>
</template>

<script type="text/javascript">
import Multiselect from 'vue-multiselect'
import { getOds } from '../../../api/ods.service.js'

export default {
  name: "Search",
  components: { Multiselect },
  data() {
    return {
      selected: null,
      filter: {
        q: '',
        ods: {},
        actionType: ''
      },
      filterButtons: {},
      showClearFilterBtn: false,
      options: []
    }
  },
  created () {
    getOds()
      .then(
        success => {
          this.options = success.data.items
        },
        error => {
          console.log(error.response)
        }
    )
  },
  methods: {
    labelODS(option) {
      return `${ option.library } - ${ option.language }`
    },
    sendEvent() {
      this.$emit('input', this.filter)
      this.showClearFilterBtn = true
      setTimeout(() => this.$emit('input', {}), 500)
    },
    clearFilter() {
      this.filter = { q: '', ods: {}, actionType: '' }
      this.$emit('input', {})
      this.clearFilterButtons()
      this.showClearFilterBtn = false
    },
    clearFilterButtons () {
      this.filterButtons = {}
    },
    getInitiativesByAction (action) {
      this.clearFilterButtons()
      this.filterButtons[action] = true
      this.showClearFilterBtn = true

      this.filter.actionType = action
      this.$emit('input', this.filter)
    }
  }
}
</script>

<style scoped lang="scss">
  .search {
    margin-bottom: 30px;
    margin-top: 30px;
    padding-left: 20px;
    padding-right: 20px;

    @media (min-width: 768px) {
      padding-left: 0 !important;
      padding-right: 0 !important;
    }
  }
  .subtitle, footer, footer a {
    color: #304c5f;
  }

  .button.is-filter, .button.is-clear {
    height: 40px;
    width: 100%;
  }
  .button.is-filter {
    background-color: #4ba146 !important;
  }

  .subtitle {
    font-size: 2.8em;
    font-weight: 300;

    &:before, &:after {
      border-bottom: 1px solid #304c5f;
      content: '';      
      display: block;
      height: 10px;
    }

    &:before {
      width: 45px;
      margin: auto;
      position: relative;
      top: 203px;

      @media (min-width: 768px) {
        top: 68px !important;
      }

    }
    &:after {
      width: 75px;
      margin: 10px auto;        
    }

  }

  .control.has-icons-right {
    .icon {
      margin-top: 13px;
    }

  }
  .input {
    border: 1px solid #e8e8e8;
    min-height: 40px;
  }

  .subtitle span {
    color: #4ba146;
    text-transform: uppercase;
  }

  .tags {
    display: flex;
    justify-content: center;

    @media (min-width: 768px) {
      justify-content: space-between  !important;
    }
  }

  .tag, .tags .button {
    background: #4ba146;
    border-radius: 100px;
    border: none;
    color: #fff;
    font-size: 1em;
    padding: 8px 35px !important;
    height: auto !important;
    // padding-right:35px;
    // padding-left:35px;
    // text-transform: uppercase;

    &:hover, &.active {
      // background: red !important;
      background: #257d1f !important;
      cursor: pointer;
    }
  }
</style>